Package com.google.protobuf

# Class GeneratedMessageV3.ExtendableBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>

java.lang.Object
com.google.protobuf.AbstractMessageLite.Builder
com.google.protobuf.AbstractMessage.Builder<BuilderT>
com.google.protobuf.GeneratedMessageV3.Builder<BuilderT>
com.google.protobuf.GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>

All Implemented Interfaces:
  `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT>`, `Message.Builder`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Cloneable`

Direct Known Subclasses:
  `DescriptorProtos.EnumOptions.Builder`, `DescriptorProtos.EnumValueOptions.Builder`, `DescriptorProtos.ExtensionRangeOptions.Builder`, `DescriptorProtos.FieldOptions.Builder`, `DescriptorProtos.FileOptions.Builder`, `DescriptorProtos.MessageOptions.Builder`, `DescriptorProtos.MethodOptions.Builder`, `DescriptorProtos.OneofOptions.Builder`, `DescriptorProtos.ServiceOptions.Builder`

Enclosing class:
  GeneratedMessageV3

public abstract static class GeneratedMessageV3.ExtendableBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>> extends GeneratedMessageV3.Builder<BuilderT> implements GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT>
Generated message builders for message types that contain extension ranges subclass this.

This class implements type-safe accessors for extensions. They implement all the same operations that you can do with normal fields -- e.g. "get", "set", and "add" -- but for extensions. The extensions are identified using instances of the class `GeneratedMessage.GeneratedExtension`; the protocol compiler generates a static instance of this class for every extension in its input. Through the magic of generics, all is made type-safe.

For example, imagine you have the `.proto` file:

     option java_class = "MyProto";

     message Foo {
       extensions 1000 to max;
     }

     extend Foo {
       optional int32 bar;
     }

Then you might write code like:

     MyProto.Foo foo =
       MyProto.Foo.newBuilder()
         .setExtension(MyProto.bar, 123)
         .build();

See also `GeneratedMessageV3.ExtendableMessage`.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ExtendableBuilder()`
`protected`
`ExtendableBuilder(GeneratedMessageV3.BuilderParent parent)`

## Method Summary

Modifier and Type
Method
Description
`final <T> BuilderT`
`addExtension(Extension<MessageT,List<T>> extension, T value)`
Append a value to a repeated extension.
`final <T> BuilderT`
`addExtension(ExtensionLite<MessageT,List<T>> extensionLite, T value)`
Append a value to a repeated extension.
`<T> BuilderT`
`addExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, T value)`
Append a value to a repeated extension.
`BuilderT`
`addRepeatedField(Descriptors.FieldDescriptor field, Object value)`
Like `setRepeatedField`, but appends the value as a new element.
`BuilderT`
`clear()`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
`final <T> BuilderT`
`clearExtension(Extension<MessageT,T> extension)`
Clear an extension.
`final <T> BuilderT`
`clearExtension(ExtensionLite<MessageT,T> extensionLite)`
Clear an extension.
`<T> BuilderT`
`clearExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)`
Clears an extension.
`BuilderT`
`clearField(Descriptors.FieldDescriptor field)`
Clears the field.
`protected boolean`
`extensionsAreInitialized()`
Called by subclasses to check if all extensions are initialized.
`Map<Descriptors.FieldDescriptor,Object>`
`getAllFields()`
Returns a collection of all the fields in this message which are set and their corresponding values.
`final <T> T`
`getExtension(Extension<MessageT,List<T>> extension, int index)`
Get the value of an extension.
`final <T> T`
`getExtension(Extension<MessageT,T> extension)`
Get the value of an extension.
`final <T> T`
`getExtension(ExtensionLite<MessageT,List<T>> extensionLite, int index)`
Get one element of a repeated extension.
`final <T> T`
`getExtension(ExtensionLite<MessageT,T> extensionLite)`
Get the value of an extension.
`final <T> T`
`getExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, int index)`
Get the value of an extension.
`final <T> T`
`getExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)`
Get the value of an extension.
`final <T> int`
`getExtensionCount(Extension<MessageT,List<T>> extension)`
Get the number of elements in a repeated extension.
`final <T> int`
`getExtensionCount(ExtensionLite<MessageT,List<T>> extensionLite)`
Get the number of elements in a repeated extension.
`final <T> int`
`getExtensionCount(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension)`
Get the number of elements in a repeated extension.
`Object`
`getField(Descriptors.FieldDescriptor field)`
Obtains the value of the given field, or the default value if it is not set.
`Message.Builder`
`getFieldBuilder(Descriptors.FieldDescriptor field)`
Get a nested builder instance for the given field.
`Object`
`getRepeatedField(Descriptors.FieldDescriptor field, int index)`
Gets an element of a repeated field.
`Message.Builder`
`getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)`
Get a nested builder instance for the given repeated field instance.
`int`
`getRepeatedFieldCount(Descriptors.FieldDescriptor field)`
Gets the number of elements of a repeated field.
`final <T> boolean`
`hasExtension(Extension<MessageT,T> extension)`
Check if a singular extension is present.
`final <T> boolean`
`hasExtension(ExtensionLite<MessageT,T> extensionLite)`
Check if a singular extension is present.
`final <T> boolean`
`hasExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)`
Check if a singular extension is present.
`boolean`
`hasField(Descriptors.FieldDescriptor field)`
Returns true if the given field is set.
`boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`protected final void`
`mergeExtensionFields(GeneratedMessageV3.ExtendableMessage<?> other)`
`Message.Builder`
`newBuilderForField(Descriptors.FieldDescriptor field)`
Create a builder for messages of the appropriate type for the given field.
`protected boolean`
`parseUnknownField(CodedInputStream input, ExtensionRegistryLite extensionRegistry, int tag)`
Called by generated subclasses to parse an unknown field.
`final <T> BuilderT`
`setExtension(Extension<MessageT,List<T>> extension, int index, T value)`
Set the value of one element of a repeated extension.
`final <T> BuilderT`
`setExtension(Extension<MessageT,T> extension, T value)`
Set the value of an extension.
`final <T> BuilderT`
`setExtension(ExtensionLite<MessageT,List<T>> extensionLite, int index, T value)`
Set the value of one element of a repeated extension.
`final <T> BuilderT`
`setExtension(ExtensionLite<MessageT,T> extensionLite, T value)`
Set the value of an extension.
`<T> BuilderT`
`setExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, int index, T value)`
Set the value of one element of a repeated extension.
`<T> BuilderT`
`setExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension, T value)`
Set the value of an extension.
`BuilderT`
`setField(Descriptors.FieldDescriptor field, Object value)`
Sets a field to the given value.
`BuilderT`
`setRepeatedField(Descriptors.FieldDescriptor field, int index, Object value)`
Sets an element of a repeated field to the given value.

### Methods inherited from class com.google.protobuf.GeneratedMessageV3.Builder

`clearOneof, clone, getDescriptorForType, getOneofFieldDescriptor, getParentForChildren, getUnknownFields, getUnknownFieldSetBuilder, hasOneof, internalGetFieldAccessorTable, internalGetMapField, internalGetMutableMapField, isClean, markClean, mergeUnknownFields, mergeUnknownLengthDelimitedField, mergeUnknownVarintField, onBuilt, onChanged, setUnknownFields, setUnknownFieldSetBuilder, setUnknownFieldsProto3`

### Methods inherited from class com.google.protobuf.AbstractMessage.Builder

`findInitializationErrors, getInitializationErrorString, internalMergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

`addAll, addAll, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, newUninitializedMessageException`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.GeneratedMessageV3.ExtendableMessageOrBuilder

`getDefaultInstanceForType`

### Methods inherited from interface com.google.protobuf.Message.Builder

`build, buildPartial, mergeDelimitedFrom, mergeDelimitedFrom`

### Methods inherited from interface com.google.protobuf.MessageLite.Builder

`mergeFrom`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getInitializationErrorString, getOneofFieldDescriptor, getUnknownFields, hasOneof`

## Constructor Details

### ExtendableBuilder

protected ExtendableBuilder()

### ExtendableBuilder

protected ExtendableBuilder(GeneratedMessageV3.BuilderParent parent)

## Method Details

### clear

public BuilderT clear()
Description copied from class: `GeneratedMessageV3.Builder`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.

Specified by:
  `clear` in interface `Message.Builder`
Specified by:
  `clear` in interface `MessageLite.Builder`
Overrides:
  `clear` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### hasExtension

public final <T> boolean hasExtension(ExtensionLite<MessageT,T> extensionLite)
Check if a singular extension is present.

Specified by:
  `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtensionCount

public final <T> int getExtensionCount(ExtensionLite<MessageT,List<T>> extensionLite)
Get the number of elements in a repeated extension.

Specified by:
  `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(ExtensionLite<MessageT,T> extensionLite)
Get the value of an extension.

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(ExtensionLite<MessageT,List<T>> extensionLite, int index)
Get one element of a repeated extension.

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### setExtension

public final <T> BuilderT setExtension(ExtensionLite<MessageT,T> extensionLite, T value)
Set the value of an extension.

### setExtension

public final <T> BuilderT setExtension(ExtensionLite<MessageT,List<T>> extensionLite, int index, T value)
Set the value of one element of a repeated extension.

### addExtension

public final <T> BuilderT addExtension(ExtensionLite<MessageT,List<T>> extensionLite, T value)
Append a value to a repeated extension.

### clearExtension

public final <T> BuilderT clearExtension(ExtensionLite<MessageT,T> extensionLite)
Clear an extension.

### hasExtension

public final <T> boolean hasExtension(Extension<MessageT,T> extension)
Check if a singular extension is present.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### hasExtension

public final <T> boolean hasExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)
Check if a singular extension is present.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtensionCount

public final <T> int getExtensionCount(Extension<MessageT,List<T>> extension)
Get the number of elements in a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtensionCount

public final <T> int getExtensionCount(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension)
Get the number of elements in a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(Extension<MessageT,T> extension)
Get the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)
Get the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(Extension<MessageT,List<T>> extension, int index)
Get the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, int index)
Get the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### setExtension

public final <T> BuilderT setExtension(Extension<MessageT,T> extension, T value)
Set the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

### setExtension

public <T> BuilderT setExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension, T value)
Set the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

### setExtension

public final <T> BuilderT setExtension(Extension<MessageT,List<T>> extension, int index, T value)
Set the value of one element of a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

### setExtension

public <T> BuilderT setExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, int index, T value)
Set the value of one element of a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

### addExtension

public final <T> BuilderT addExtension(Extension<MessageT,List<T>> extension, T value)
Append a value to a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

### addExtension

public <T> BuilderT addExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, T value)
Append a value to a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

### clearExtension

public final <T> BuilderT clearExtension(Extension<MessageT,T> extension)
Clear an extension.

TODO(b/258340024): handled by ExtensionLite version

### clearExtension

public <T> BuilderT clearExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)
Clears an extension.

TODO(b/258340024): handled by ExtensionLite version

### extensionsAreInitialized

protected boolean extensionsAreInitialized()
Called by subclasses to check if all extensions are initialized.

### isInitialized

public boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### getAllFields

public Map<Descriptors.FieldDescriptor,Object> getAllFields()
Description copied from interface: `MessageOrBuilder`
Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.

Specified by:
  `getAllFields` in interface `MessageOrBuilder`
Overrides:
  `getAllFields` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### getField

public Object getField(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.

Specified by:
  `getField` in interface `MessageOrBuilder`
Overrides:
  `getField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### getFieldBuilder

public Message.Builder getFieldBuilder(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Get a nested builder instance for the given field.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations (the generated message builders) can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder is returned. Otherwise, a new field builder is created and returned. The original message field (if one exists) is merged into the field builder, which is then nested into its parent builder.

Specified by:
  `getFieldBuilder` in interface `Message.Builder`
Overrides:
  `getFieldBuilder` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### getRepeatedFieldCount

public int getRepeatedFieldCount(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.

Specified by:
  `getRepeatedFieldCount` in interface `MessageOrBuilder`
Overrides:
  `getRepeatedFieldCount` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### getRepeatedField

public Object getRepeatedField(Descriptors.FieldDescriptor field, int index)
Description copied from interface: `MessageOrBuilder`
Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.

Specified by:
  `getRepeatedField` in interface `MessageOrBuilder`
Overrides:
  `getRepeatedField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### getRepeatedFieldBuilder

public Message.Builder getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)
Description copied from interface: `Message.Builder`
Get a nested builder instance for the given repeated field instance.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations (the generated message builders) can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder is returned. Otherwise, a new field builder is created and returned. The original message field (if one exists) is merged into the field builder, which is then nested into its parent builder.

Specified by:
  `getRepeatedFieldBuilder` in interface `Message.Builder`
Overrides:
  `getRepeatedFieldBuilder` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### hasField

public boolean hasField(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.

Specified by:
  `hasField` in interface `MessageOrBuilder`
Overrides:
  `hasField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### setField

public BuilderT setField(Descriptors.FieldDescriptor field, Object value)
Description copied from interface: `Message.Builder`
Sets a field to the given value. The value must be of the correct type for this field, that is, the same type that `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` returns.

Specified by:
  `setField` in interface `Message.Builder`
Overrides:
  `setField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### clearField

public BuilderT clearField(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Clears the field. This is exactly equivalent to calling the generated "clear" accessor method corresponding to the field.

Specified by:
  `clearField` in interface `Message.Builder`
Overrides:
  `clearField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### setRepeatedField

public BuilderT setRepeatedField(Descriptors.FieldDescriptor field, int index, Object value)
Description copied from interface: `Message.Builder`
Sets an element of a repeated field to the given value. The value must be of the correct type for this field; that is, the same type that `MessageOrBuilder.getRepeatedField(Descriptors.FieldDescriptor,int)` returns.

Specified by:
  `setRepeatedField` in interface `Message.Builder`
Overrides:
  `setRepeatedField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### addRepeatedField

public BuilderT addRepeatedField(Descriptors.FieldDescriptor field, Object value)
Description copied from interface: `Message.Builder`
Like `setRepeatedField`, but appends the value as a new element.

Specified by:
  `addRepeatedField` in interface `Message.Builder`
Overrides:
  `addRepeatedField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### newBuilderForField

public Message.Builder newBuilderForField(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Create a builder for messages of the appropriate type for the given field. The builder is NOT nested in the current builder. However, messages built with the builder can then be passed to the `Message.Builder.setField(Descriptors.FieldDescriptor, Object)`, `Message.Builder.setRepeatedField(Descriptors.FieldDescriptor, int, Object)`, or `Message.Builder.addRepeatedField(Descriptors.FieldDescriptor, Object)` method of the current builder.

To obtain a builder nested in the current builder, use `Message.Builder.getFieldBuilder(Descriptors.FieldDescriptor)` instead.

Specified by:
  `newBuilderForField` in interface `Message.Builder`
Overrides:
  `newBuilderForField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`

### mergeExtensionFields

protected final void mergeExtensionFields(GeneratedMessageV3.ExtendableMessage<?> other)

### parseUnknownField

protected boolean parseUnknownField(CodedInputStream input, ExtensionRegistryLite extensionRegistry, int tag) throws IOException
Description copied from class: `GeneratedMessageV3.Builder`
Called by generated subclasses to parse an unknown field.

Overrides:
  `parseUnknownField` in class `GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>`
Returns:
  `true` unless the tag is an end-group tag.
Throws:
  `IOException`